'''
Created on 17 Oct 2017

@author: Laura
'''
import utils.numericlibrary

#from numeFisier import numeFc

'''
Descr: computes the sum of two rational numbers    
Data: r1, r2
Precondition: r1, r2 - rational numbers 
Results: rs
Postcondition:rs - rational number, rs = r1 + r2  
'''
def sum(r1, r2):
    numerator = r1[0] * r2[1] + r1[1] * r2[0]
    denominator = r1[1] * r2[1]
#     divisor = utils.numericlibrary.gcd(numerator, denominator)
#     rs = [numerator / divisor, denominator / divisor]
    rs = simplificare([numerator, denominator])
    return rs 
   
def test_sum():
    assert sum([2, 3], [4, 5]) == [22, 15]
    assert sum([1, 4], [1, 4]) == [1, 2]
    assert sum([1, 2], [1, 2]) == [1, 1]
    
test_sum()

'''
D: simplifica o fractie la forma ireduc
I: fractia prin lista cu numara si numitor
O: fractia ired in forma de lista cu numar si numit
'''
def simplificare(r):
    
    d = utils.numericlibrary.gcd(r[0], r[1])
    r[0] = r[0] / d
    r[1] = r[1] / d
    return r

def testSimplificare():
    assert (simplificare([2,4]) == [1,2])

testSimplificare()